/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.28 from the
 * contents of Packet.xs. Do not edit this file, edit Packet.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Socket/Packet.xs"
/*  You may distribute under the terms of either the GNU General Public License
 *  or the Artistic License (the same terms as Perl itself)
 *
 *  (C) Paul Evans, 2009,2010 -- leonerd@leonerd.org.uk
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <sys/mman.h>
#include <sys/socket.h>
#include <net/ethernet.h>
#include <linux/if.h>
#include <linux/if_packet.h>

/* Borrowed from IO/Sockatmark.xs */

#ifdef PerlIO
typedef PerlIO * InputStream;
#else
#define PERLIO_IS_STDIO 1
typedef FILE * InputStream;
#define PerlIO_fileno(f) fileno(f)
#endif

/* Lower and upper bounds of a valid struct sockaddr_ll */
static int sll_max;
static int sll_min;
/* Maximum number of address bytes in a struct sockaddr_ll */
static int sll_maxaddr;

#ifndef PUSHmortal
# define PUSHmortal PUSHs(sv_newmortal())
#endif

#ifndef mPUSHi
# define mPUSHi(iv) sv_setiv(PUSHmortal, iv)
#endif

#ifndef mPUSHn
# define mPUSHn(nv) sv_setnv(PUSHmortal, nv)
#endif

#ifndef mPUSHp
# define mPUSHp(p,l) sv_setpvn(PUSHmortal, p, l)
#endif

#define HVSTOREi(hv,name,iv)     sv_setiv(*hv_fetch(hv, ""name"", sizeof(""name"")-1, 1), iv)
#define HVSTOREp(hv,name,pv,len) sv_setpvn(*hv_fetch(hv, ""name"", sizeof(""name"")-1, 1), pv, len)

#if defined(HAVE_TPACKET) || defined(HAVE_TPACKET2)
# define HAVE_RX_RING
static int free_rxring_state(pTHX_ SV *, MAGIC *);

static MGVTBL vtbl = {
  NULL, /* get */
  NULL, /* set */
  NULL, /* len */
  NULL, /* clear */
  &free_rxring_state, /* free */
};

struct packet_rxring_state
{
  char *buffer;
  unsigned int frame_size;
  unsigned int frame_nr;
  unsigned int frame_idx;
};

static int free_rxring_state(pTHX_ SV *sv, MAGIC *mg)
{
  free(mg->mg_ptr);
  return 0;
}

static struct packet_rxring_state *get_rxring_state(SV *sv)
{
  MAGIC *magic;

  for(magic = mg_find(sv, PERL_MAGIC_ext); magic; magic = magic->mg_moremagic) {
    if(magic->mg_type == PERL_MAGIC_ext && magic->mg_virtual == &vtbl) {
      return (struct packet_rxring_state *)magic->mg_ptr;
    }
  }

  croak("Cannot find rxring state - call setup_rx_ring() first");
}

static void *frame_ptr(struct packet_rxring_state *state)
{
  return state->buffer + (state->frame_size * state->frame_idx);
}
#endif

static void setup_constants(void)
{
  sll_max = sizeof(struct sockaddr_ll);
  sll_maxaddr = sizeof(((struct sockaddr_ll*)NULL)->sll_addr);
  sll_min = sll_max - sll_maxaddr;

  HV *stash;
  AV *export;

  stash = gv_stashpvn("Socket::Packet", 14, TRUE);
  export = get_av("Socket::Packet::EXPORT", TRUE);

#define DO_CONSTANT(c) \
  newCONSTSUB(stash, #c, newSViv(c)); \
  av_push(export, newSVpv(#c, 0));


  DO_CONSTANT(PF_PACKET)
  DO_CONSTANT(AF_PACKET)

  DO_CONSTANT(PACKET_HOST)
  DO_CONSTANT(PACKET_BROADCAST)
  DO_CONSTANT(PACKET_MULTICAST)
  DO_CONSTANT(PACKET_OTHERHOST)
  DO_CONSTANT(PACKET_OUTGOING)

  DO_CONSTANT(ETH_P_ALL)

  DO_CONSTANT(SOL_PACKET)

  DO_CONSTANT(PACKET_ADD_MEMBERSHIP)
  DO_CONSTANT(PACKET_DROP_MEMBERSHIP)
  DO_CONSTANT(PACKET_STATISTICS)
#ifdef HAVE_ORIGDEV
  DO_CONSTANT(PACKET_ORIGDEV)
#endif

  DO_CONSTANT(PACKET_MR_MULTICAST)
  DO_CONSTANT(PACKET_MR_PROMISC)
  DO_CONSTANT(PACKET_MR_ALLMULTI)

#ifdef HAVE_RX_RING
  DO_CONSTANT(TP_STATUS_KERNEL)
  DO_CONSTANT(TP_STATUS_USER)
  DO_CONSTANT(TP_STATUS_COPY)
  DO_CONSTANT(TP_STATUS_LOSING)
  DO_CONSTANT(TP_STATUS_CSUMNOTREADY)
#endif
}

#line 157 "lib/Socket/Packet.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 301 "lib/Socket/Packet.c"

XS_EUPXS(XS_Socket__Packet_pack_sockaddr_ll); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Socket__Packet_pack_sockaddr_ll)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "protocol, ifindex, hatype, pkttype, addr");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	unsigned short	protocol = (unsigned short)SvUV(ST(0))
;
	int	ifindex = (int)SvIV(ST(1))
;
	unsigned short	hatype = (unsigned short)SvUV(ST(2))
;
	unsigned char	pkttype = (unsigned char)SvUV(ST(3))
;
	SV *	addr = ST(4)
;
#line 161 "lib/Socket/Packet.xs"
    struct sockaddr_ll sll;
    char *addrbytes;
    STRLEN addrlen;

#line 327 "lib/Socket/Packet.c"
#line 166 "lib/Socket/Packet.xs"
    if (DO_UTF8(addr) && !sv_utf8_downgrade(addr, 1))
      croak("Wide character in Socket::Packet::pack_sockaddr_ll");

    addrbytes = SvPVbyte(addr, addrlen);

    if(addrlen > sll_maxaddr)
      croak("addr too long; should be no more than %d bytes, found %d", sll_maxaddr, addrlen);

    sll.sll_family   = AF_PACKET;
    sll.sll_protocol = htons(protocol);
    sll.sll_ifindex  = ifindex;
    sll.sll_hatype   = hatype;
    sll.sll_pkttype  = pkttype;

    sll.sll_halen    = addrlen;
    Zero(&sll.sll_addr, sll_maxaddr, char);
    Copy(addrbytes, &sll.sll_addr, addrlen, char);

    EXTEND(SP, 1);
    mPUSHp((char *)&sll, sizeof sll);
#line 349 "lib/Socket/Packet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Socket__Packet_unpack_sockaddr_ll); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Socket__Packet_unpack_sockaddr_ll)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sa");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	sa = ST(0)
;
#line 192 "lib/Socket/Packet.xs"
    STRLEN sa_len;
    char *sa_bytes;
    struct sockaddr_ll sll;

#line 372 "lib/Socket/Packet.c"
#line 197 "lib/Socket/Packet.xs"
    /* variable size of structure, because of variable length of addr bytes */
    sa_bytes = SvPVbyte(sa, sa_len);
    if(sa_len < sll_min)
      croak("Socket address too small; found %d bytes, expected at least %d", sa_len, sll_min);
    if(sa_len > sll_max)
      croak("Socket address too big; found %d bytes, expected at most %d", sa_len, sll_max);

    Copy(sa_bytes, &sll, sizeof sll, char);

    if(sa_len < sll_min + sll.sll_halen)
      croak("Socket address too small; it did not provide enough bytes for sll_halen of %d", sll.sll_halen);

    if(sll.sll_family != AF_PACKET)
      croak("Bad address family for unpack_sockaddr_ll: got %d, expected %d", sll.sll_family, AF_PACKET);

    EXTEND(SP, 5);
    mPUSHi(ntohs(sll.sll_protocol));
    mPUSHi(sll.sll_ifindex);
    mPUSHi(sll.sll_hatype);
    mPUSHi(sll.sll_pkttype);
    mPUSHp((char *)sll.sll_addr, sll.sll_halen);
#line 395 "lib/Socket/Packet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Socket__Packet_pack_packet_mreq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Socket__Packet_pack_packet_mreq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ifindex, type, addr");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	ifindex = (int)SvIV(ST(0))
;
	unsigned short	type = (unsigned short)SvUV(ST(1))
;
	SV *	addr = ST(2)
;
#line 226 "lib/Socket/Packet.xs"
    struct packet_mreq mreq;
    char  *addr_bytes;
    STRLEN addr_len;

#line 422 "lib/Socket/Packet.c"
#line 231 "lib/Socket/Packet.xs"
    if (DO_UTF8(addr) && !sv_utf8_downgrade(addr, 1))
      croak("Wide character in Socket::Packet::pack_sockaddr_ll");

    addr_bytes = SvPVbyte(addr, addr_len);

    if(addr_len > sizeof(mreq.mr_address))
      croak("addr too long; should be no more than %d bytes, found %d", sizeof(mreq.mr_address), addr_len);

    mreq.mr_ifindex = ifindex;
    mreq.mr_type    = type;

    mreq.mr_alen = addr_len;
    Zero(&mreq.mr_address, sizeof(mreq.mr_address), char);
    Copy(addr_bytes, &mreq.mr_address, addr_len, char);

    EXTEND(SP, 1);
    mPUSHp((char *)&mreq, sizeof mreq);
#line 441 "lib/Socket/Packet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Socket__Packet_unpack_packet_mreq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Socket__Packet_unpack_packet_mreq)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "data");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	data = ST(0)
;
#line 254 "lib/Socket/Packet.xs"
    STRLEN data_len;
    char *data_bytes;
    struct packet_mreq mreq;

#line 464 "lib/Socket/Packet.c"
#line 259 "lib/Socket/Packet.xs"
    data_bytes = SvPVbyte(data, data_len);
    if(data_len != sizeof(mreq))
      croak("packet_mreq buffer incorrect size; found %d bytes, expected %d", data_len, sizeof(mreq));

    Copy(data_bytes, &mreq, data_len, char);

    if(mreq.mr_alen > sizeof(mreq.mr_address))
      croak("packet_mreq claims to have a larger address than it has space for");

    EXTEND(SP, 3);
    mPUSHi(mreq.mr_ifindex);
    mPUSHi(mreq.mr_type);
    mPUSHp(mreq.mr_address, mreq.mr_alen);
#line 479 "lib/Socket/Packet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Socket__Packet_unpack_tpacket_stats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Socket__Packet_unpack_tpacket_stats)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "stats");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	stats = ST(0)
;
#line 278 "lib/Socket/Packet.xs"
    STRLEN stats_len;
    char *stats_bytes;
    struct tpacket_stats statsbuf;

#line 502 "lib/Socket/Packet.c"
#line 283 "lib/Socket/Packet.xs"
    stats_bytes = SvPVbyte(stats, stats_len);
    if(stats_len != sizeof(statsbuf))
      croak("tpacket_stats buffer incorrect size; found %d bytes, expected %d", stats_len, sizeof(statsbuf));

    Copy(stats_bytes, &statsbuf, stats_len, char);

    EXTEND(SP, 5);
    mPUSHi(statsbuf.tp_packets);
    mPUSHi(statsbuf.tp_drops);
#line 513 "lib/Socket/Packet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Socket__Packet_siocgstamp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Socket__Packet_siocgstamp)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sock");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	InputStream	sock = IoIFP(sv_2io(ST(0)))
;
#line 299 "lib/Socket/Packet.xs"
    int fd;
    int result;
    struct timeval tv;

#line 536 "lib/Socket/Packet.c"
#line 304 "lib/Socket/Packet.xs"
    fd = PerlIO_fileno(sock);
    if(ioctl(fd, SIOCGSTAMP, &tv) == -1) {
      if(GIMME_V == G_ARRAY)
        return;
      else
        XSRETURN_UNDEF;
    }

    if(GIMME_V == G_ARRAY) {
      EXTEND(SP, 2);
      mPUSHi(tv.tv_sec);
      mPUSHi(tv.tv_usec);
    }
    else {
      mPUSHn((double)tv.tv_sec + (tv.tv_usec / 1000000.0));
    }
#line 554 "lib/Socket/Packet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Socket__Packet_siocgstampns); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Socket__Packet_siocgstampns)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sock");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	InputStream	sock = IoIFP(sv_2io(ST(0)))
;
#line 327 "lib/Socket/Packet.xs"
    int fd;
    int result;
    struct timespec ts;

#line 577 "lib/Socket/Packet.c"
#line 332 "lib/Socket/Packet.xs"
#ifdef SIOCGSTAMPNS
    fd = PerlIO_fileno(sock);
    if(ioctl(fd, SIOCGSTAMPNS, &ts) == -1) {
      if(GIMME_V == G_ARRAY)
        return;
      else
        XSRETURN_UNDEF;
    }

    if(GIMME_V == G_ARRAY) {
      EXTEND(SP, 2);
      mPUSHi(ts.tv_sec);
      mPUSHi(ts.tv_nsec);
    }
    else {
      mPUSHn((double)ts.tv_sec + (ts.tv_nsec / 1000000000.0));
    }
#else
    croak("SIOCGSTAMPNS not implemented");
#endif
#line 599 "lib/Socket/Packet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Socket__Packet_siocgifindex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Socket__Packet_siocgifindex)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sock, ifname");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	InputStream	sock = IoIFP(sv_2io(ST(0)))
;
	char *	ifname = (char *)SvPV_nolen(ST(1))
;
#line 360 "lib/Socket/Packet.xs"
    int fd;
    struct ifreq req;

#line 623 "lib/Socket/Packet.c"
#line 364 "lib/Socket/Packet.xs"
#ifdef SIOCGIFINDEX
    fd = PerlIO_fileno(sock);
    strncpy(req.ifr_name, ifname, IFNAMSIZ);
    if(ioctl(fd, SIOCGIFINDEX, &req) == -1)
      XSRETURN_UNDEF;
    mPUSHi(req.ifr_ifindex);
#else
    croak("SIOCGIFINDEX not implemented");
#endif
#line 634 "lib/Socket/Packet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Socket__Packet_siocgifname); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Socket__Packet_siocgifname)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sock, ifindex");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	InputStream	sock = IoIFP(sv_2io(ST(0)))
;
	int	ifindex = (int)SvIV(ST(1))
;
#line 381 "lib/Socket/Packet.xs"
    int fd;
    struct ifreq req;

#line 658 "lib/Socket/Packet.c"
#line 385 "lib/Socket/Packet.xs"
#ifdef SIOCGIFNAME
    fd = PerlIO_fileno(sock);
    req.ifr_ifindex = ifindex;
    if(ioctl(fd, SIOCGIFNAME, &req) == -1)
      XSRETURN_UNDEF;
    PUSHs(sv_2mortal(newSVpv(req.ifr_name, 0)));
#else
    croak("SIOCGIFNAME not implemented");
#endif
#line 669 "lib/Socket/Packet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Socket__Packet_recv_len); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Socket__Packet_recv_len)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "sock, buffer, maxlen, flags");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	InputStream	sock = IoIFP(sv_2io(ST(0)))
;
	SV *	buffer = ST(1)
;
	int	maxlen = (int)SvIV(ST(2))
;
	int	flags = (int)SvIV(ST(3))
;
#line 403 "lib/Socket/Packet.xs"
    int fd;
    char *bufferp;
    struct sockaddr_storage addr;
    socklen_t addrlen;
    int len;

#line 700 "lib/Socket/Packet.c"
#line 410 "lib/Socket/Packet.xs"
    fd = PerlIO_fileno(sock);

    if(!SvOK(buffer))
      sv_setpvn(buffer, "", 0);

    bufferp = SvGROW(buffer, (STRLEN)(maxlen+1));

    addrlen = sizeof(addr);

    len = recvfrom(fd, bufferp, maxlen, flags, (struct sockaddr *)&addr, &addrlen);

    if(len < 0)
      XSRETURN(0);

    if(len > maxlen)
      SvCUR_set(buffer, maxlen);
    else
      SvCUR_set(buffer, len);

    *SvEND(buffer) = '\0';
    SvPOK_only(buffer);

    mPUSHp((char *)&addr, addrlen);
    mPUSHi(len);
#line 726 "lib/Socket/Packet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Socket__Packet_setup_rx_ring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Socket__Packet_setup_rx_ring)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "sock, frame_size, frame_nr, block_size");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	InputStream	sock = IoIFP(sv_2io(ST(0)))
;
	unsigned int	frame_size = (unsigned int)SvUV(ST(1))
;
	unsigned int	frame_nr = (unsigned int)SvUV(ST(2))
;
	unsigned int	block_size = (unsigned int)SvUV(ST(3))
;
#line 443 "lib/Socket/Packet.xs"
    int fd;
    int version;
    struct tpacket_req req;
    size_t size;
    char *addr;

#line 757 "lib/Socket/Packet.c"
#line 450 "lib/Socket/Packet.xs"
#ifdef HAVE_RX_RING
    fd = PerlIO_fileno(sock);
#ifdef HAVE_TPACKET2
    version = TPACKET_V2;
    if(setsockopt(fd, SOL_PACKET, PACKET_VERSION, &version, sizeof version) != 0)
      XSRETURN_UNDEF;
#endif

    {
      struct tpacket_req req;
      req.tp_frame_size = frame_size;
      req.tp_frame_nr   = frame_nr;
      req.tp_block_size = block_size;
      req.tp_block_nr   = (frame_size * frame_nr) / block_size;
      if(setsockopt(fd, SOL_PACKET, PACKET_RX_RING, &req, sizeof req) != 0)
        XSRETURN_UNDEF;

      size = req.tp_block_size * req.tp_block_nr;
    }

    addr = mmap(0, size, PROT_READ|PROT_WRITE, MAP_SHARED, fd, 0);
    if(addr == MAP_FAILED)
      XSRETURN_UNDEF;

    {
      struct packet_rxring_state *state = malloc(sizeof *state);

      state->buffer     = addr;
      state->frame_size = frame_size;
      state->frame_nr   = frame_nr;
      state->frame_idx  = 0;

      sv_magicext((SV*)sv_2io(ST(0)), NULL, PERL_MAGIC_ext, &vtbl, (char *)state, 0);
    }

    ST(0) = sv_2mortal(newSViv(size));
    XSRETURN(1);
#else
    croak("setup_rx_ring() not supported on this platform");
#endif
#line 799 "lib/Socket/Packet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Socket__Packet_get_ring_frame_status); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Socket__Packet_get_ring_frame_status)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sock");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	InputStream	sock = IoIFP(sv_2io(ST(0)))
;
#line 495 "lib/Socket/Packet.xs"
#ifdef HAVE_RX_RING
    {
      struct packet_rxring_state *state = get_rxring_state((SV*)sv_2io(ST(0)));
      char *addr = frame_ptr(state);
#if defined(HAVE_TPACKET2)
      struct tpacket2_hdr *hdr = (struct tpacket2_hdr *)addr;
#elif defined(HAVE_TPACKET)
      struct tpacket_hdr *hdr = (struct tpacket_hdr *)addr;
#endif
      ST(0) = sv_2mortal(newSViv(hdr->tp_status));
    }

    XSRETURN(1);
#else
    croak("get_ring_frame_status() not supported on this platform");
#endif
#line 834 "lib/Socket/Packet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Socket__Packet_get_ring_frame); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Socket__Packet_get_ring_frame)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "sock, buffer, info");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	InputStream	sock = IoIFP(sv_2io(ST(0)))
;
	SV *	buffer = ST(1)
;
	HV *	info;
#line 520 "lib/Socket/Packet.xs"
#line 856 "lib/Socket/Packet.c"

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    info = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Socket::Packet::get_ring_frame",
				"info");
		}
	} STMT_END
;
#line 521 "lib/Socket/Packet.xs"
#ifdef HAVE_RX_RING
    {
      struct packet_rxring_state *state = get_rxring_state((SV*)sv_2io(ST(0)));
      char *addr = frame_ptr(state);
      unsigned int len;
      unsigned int snaplen;
      int mac;
      struct sockaddr_ll  *sll;
#if defined(HAVE_TPACKET2)
      struct tpacket2_hdr *hdr = (struct tpacket2_hdr *)addr;
      if((hdr->tp_status & 1) != 1)
        XSRETURN(0);

      len     = hdr->tp_len;
      snaplen = hdr->tp_snaplen;
      mac     = hdr->tp_mac;

      HVSTOREi(info, "tp_status",   hdr->tp_status);
      HVSTOREi(info, "tp_len",      hdr->tp_len);
      HVSTOREi(info, "tp_snaplen",  hdr->tp_snaplen);
      HVSTOREi(info, "tp_sec",      hdr->tp_sec);
      HVSTOREi(info, "tp_nsec",     hdr->tp_nsec);
      HVSTOREi(info, "tp_vlan_tci", hdr->tp_vlan_tci);

      sll = (struct sockaddr_ll *)(addr + TPACKET_ALIGN(sizeof(struct tpacket2_hdr)));
#elif defined(HAVE_TPACKET)
      struct tpacket_hdr *hdr = (struct tpacket_hdr *)addr;
      if((hdr->tp_status & 1) != 1)
        XSRETURN(0);

      len     = hdr->tp_len;
      snaplen = hdr->tp_snaplen;
      mac     = hdr->tp_mac;

      HVSTOREi(info, "tp_status",   hdr->tp_status);
      HVSTOREi(info, "tp_len",      hdr->tp_len);
      HVSTOREi(info, "tp_snaplen",  hdr->tp_snaplen);
      HVSTOREi(info, "tp_sec",      hdr->tp_sec);
      HVSTOREi(info, "tp_nsec",     hdr->tp_usec * 1000);

      sll = (struct sockaddr_ll *)(addr + TPACKET_ALIGN(sizeof(struct tpacket_hdr)));
#endif
      HVSTOREi(info, "sll_protocol", ntohs(sll->sll_protocol));
      HVSTOREi(info, "sll_ifindex",  sll->sll_ifindex);
      HVSTOREi(info, "sll_hatype",   sll->sll_hatype);
      HVSTOREi(info, "sll_pkttype",  sll->sll_pkttype);
      HVSTOREp(info, "sll_addr",     sll->sll_addr, sll->sll_halen);

      /* Alias, don't copy data - we like zero-copy */
      SvUPGRADE(buffer, SVt_PV);
      SvPVX(buffer) = addr + mac;
      SvCUR_set(buffer, snaplen);
      SvLEN_set(buffer, 0);
      SvPOK_only(buffer);

      sv_setiv(ST(0), len);
      XSRETURN(1);
    }
#else
    croak("get_ring_frame() not supported on this platform");
#endif
#line 933 "lib/Socket/Packet.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Socket__Packet_done_ring_frame); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Socket__Packet_done_ring_frame)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sock");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	InputStream	sock = IoIFP(sv_2io(ST(0)))
;
#line 587 "lib/Socket/Packet.xs"
#ifdef HAVE_RX_RING
    {
      struct packet_rxring_state *state = get_rxring_state((SV*)sv_2io(ST(0)));
      char *addr = frame_ptr(state);
#if defined(HAVE_TPACKET2)
      struct tpacket2_hdr *hdr = (struct tpacket2_hdr *)addr;
#elif defined(HAVE_TPACKET)
      struct tpacket_hdr *hdr = (struct tpacket_hdr *)addr;
#endif
      hdr->tp_status = TP_STATUS_KERNEL;

      state->frame_idx = (state->frame_idx + 1) % state->frame_nr;
    }

    XSRETURN(0);
#else
    croak("done_ring_frame() not supported on this platform");
#endif
#line 970 "lib/Socket/Packet.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Socket__Packet); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Socket__Packet)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Socket::Packet::pack_sockaddr_ll", XS_Socket__Packet_pack_sockaddr_ll);
        newXS_deffile("Socket::Packet::unpack_sockaddr_ll", XS_Socket__Packet_unpack_sockaddr_ll);
        newXS_deffile("Socket::Packet::pack_packet_mreq", XS_Socket__Packet_pack_packet_mreq);
        newXS_deffile("Socket::Packet::unpack_packet_mreq", XS_Socket__Packet_unpack_packet_mreq);
        newXS_deffile("Socket::Packet::unpack_tpacket_stats", XS_Socket__Packet_unpack_tpacket_stats);
        (void)newXSproto_portable("Socket::Packet::siocgstamp", XS_Socket__Packet_siocgstamp, file, "$");
        (void)newXSproto_portable("Socket::Packet::siocgstampns", XS_Socket__Packet_siocgstampns, file, "$");
        (void)newXSproto_portable("Socket::Packet::siocgifindex", XS_Socket__Packet_siocgifindex, file, "$$");
        (void)newXSproto_portable("Socket::Packet::siocgifname", XS_Socket__Packet_siocgifname, file, "$$");
        newXS_deffile("Socket::Packet::recv_len", XS_Socket__Packet_recv_len);
        newXS_deffile("Socket::Packet::setup_rx_ring", XS_Socket__Packet_setup_rx_ring);
        newXS_deffile("Socket::Packet::get_ring_frame_status", XS_Socket__Packet_get_ring_frame_status);
        newXS_deffile("Socket::Packet::get_ring_frame", XS_Socket__Packet_get_ring_frame);
        newXS_deffile("Socket::Packet::done_ring_frame", XS_Socket__Packet_done_ring_frame);

    /* Initialisation Section */

#line 150 "lib/Socket/Packet.xs"
  setup_constants();

#line 1024 "lib/Socket/Packet.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

